// Absolut TiltDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Absolut Tilt.h"
#include "Absolut TiltDlg.h"
#include "math.h"
#include "functions.h"

#include <mmsystem.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAbsolutTiltDlg-Dialogfeld




CAbsolutTiltDlg::CAbsolutTiltDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAbsolutTiltDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAbsolutTiltDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DEVICELIST, cDevList);
}

BEGIN_MESSAGE_MAP(CAbsolutTiltDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(WM_DEVICECHANGE, &CAbsolutTiltDlg::PlugInDevice) //Find devices automaticly
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_DEVICELIST, &CAbsolutTiltDlg::OnCbnSelchangeDevicelist)
END_MESSAGE_MAP()


// CAbsolutTiltDlg-Meldungshandler

BOOL CAbsolutTiltDlg::OnInitDialog()
{
	CDialog::OnInitDialog();


	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	for(int i=0; i<15; i++)
		DevSerial[i] = _T("");

	EnumHidDevices(0x1113, 0x07C0);

	for(int i=0; i<15; i++)
		if(DevSerial[i] != _T(""))
			cDevList.AddString(DevSerial[i]);


	cFont.CreateFontW(28, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, DEFAULT_CHARSET, OUT_CHARACTER_PRECIS,CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, _T("Arial"));
	GetDlgItem(IDC_XY_TILT)->SetFont(&cFont);
	GetDlgItem(IDC_X_DATA)->SetFont(&cFont);
	GetDlgItem(IDC_Y_DATA)->SetFont(&cFont);

	return TRUE;
}


void CAbsolutTiltDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


HCURSOR CAbsolutTiltDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

LRESULT CAbsolutTiltDlg::PlugInDevice(WPARAM wParam, LPARAM lParam)
{
	cDevList.ResetContent();

	for(int i=0; i<15; i++)
		DevSerial[i] = _T("");

	EnumHidDevices(0x1113, 0x07C0);

	for(int i=0; i<15; i++)
		if(DevSerial[i] != "")
			cDevList.AddString(DevSerial[i]);

	cDevList.SelectString(0, sNowSerial);

	return 0;
}

/*USB-Function: Get serialnumber from device*/
CString CAbsolutTiltDlg::GetSerialNumber(HANDLE handle)
{
	WCHAR sn[32];
	CString	serial;
	
	memset(&sn, 0, 32);
	HidD_GetSerialNumberString(handle, &sn, 32); 

	serial.Format(_T("%s"), &sn[0]);
	return serial;
}

/*USB-Function: Get Handles from specified device*/
BOOL CAbsolutTiltDlg::ConnectToUSB(ULONG productID, ULONG vendorID, CString serial)
{
	HIDD_ATTRIBUTES	Attributes;
	SP_DEVICE_INTERFACE_DATA devInfoData;
	PSP_DEVICE_INTERFACE_DETAIL_DATA detailData;
	HDEVINFO hDevInfo;
	int	MemberIndex = 0;
	int	DeviceIndex = 0;
	LONG DevInfo;
	ULONG Length = 0;
	ULONG Required;
	GUID HidGuid;

    ZeroMemory(&devInfoData, sizeof(devInfoData));
    devInfoData.cbSize = sizeof(devInfoData);

	HidD_GetHidGuid(&HidGuid);	

	hDevInfo = SetupDiGetClassDevsW(&HidGuid, NULL, NULL, DIGCF_DEVICEINTERFACE | DIGCF_PRESENT);

	do{
		DevInfo = SetupDiEnumDeviceInterfaces (hDevInfo, NULL, &HidGuid, MemberIndex, &devInfoData);

		if (DevInfo != 0)
		{
			SetupDiGetDeviceInterfaceDetail(hDevInfo, &devInfoData, NULL, 0, &Length, NULL);

			detailData = (PSP_DEVICE_INTERFACE_DETAIL_DATA) malloc(Length);
			detailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

			SetupDiGetDeviceInterfaceDetail(hDevInfo, &devInfoData, detailData, Length, &Required, NULL);

			DeviceHandle = CreateFile(detailData->DevicePath, 0, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_NO_BUFFERING, NULL);

			Attributes.Size = sizeof(Attributes);
			HidD_GetAttributes (DeviceHandle, &Attributes);

			if(Attributes.VendorID == vendorID)
			{
				if(Attributes.ProductID == productID)
				{
					GetPreparsedData(DeviceHandle);

					if((GetSerialNumber(DeviceHandle) == serial) && (serial.GetLength() > 0))
					{
						HidHandle[DeviceIndex] = CreateFile(detailData->DevicePath, 
															GENERIC_WRITE | GENERIC_READ, 
															FILE_SHARE_READ|FILE_SHARE_WRITE, 
															NULL,
															OPEN_EXISTING, 
															FILE_FLAG_NO_BUFFERING, 
															NULL);
						
						DeviceIndex++;
					}
				}
				else
					NULL;
			}
			else
			{
				CloseHandle(DeviceHandle);
			}
		free(detailData);
		}
		MemberIndex++;
	}while (DevInfo != NULL);

	SetupDiDestroyDeviceInfoList(hDevInfo);

	return 0;
}

/*USB-Function: Get informations from device*/
HIDP_CAPS CAbsolutTiltDlg::GetPreparsedData(HANDLE handle)
{
	PHIDP_PREPARSED_DATA PreparsedData;

	HidD_GetPreparsedData(handle, &PreparsedData);
	HidP_GetCaps(PreparsedData, &Capabilities);
	HidD_FreePreparsedData(PreparsedData);

	return Capabilities;
}

/*USB-Function: Read data from interface 0*/
UCHAR CAbsolutTiltDlg::ReadPipOne(HANDLE handle)
{
	DWORD NumberOfBytesRead = 0;

	memset(&PipeOne, 0, Capabilities.InputReportByteLength+1);
	PipeOne[0] = 0x00;
	
	ReadFile(handle, &PipeOne, Capabilities.InputReportByteLength, &NumberOfBytesRead, NULL);
	return 0;
}

short CAbsolutTiltDlg::CalcPipeOne(UCHAR lsb, UCHAR msb)
{
	short erg;
	short LSB, MSB;

	MSB = msb;
	MSB = MSB & 0x00FF;
	LSB = (lsb & 0x03) << 8; // *256
	LSB = LSB & 0x0300;

	erg = MSB | LSB ;

	return erg;
}

/*USB-Function: Enumerate all specified devices an store their serialnumber*/
int CAbsolutTiltDlg::EnumHidDevices(ULONG productID, ULONG vendorID)
{
	HIDD_ATTRIBUTES	Attributes;
	SP_DEVICE_INTERFACE_DATA devInfoData;
	PSP_DEVICE_INTERFACE_DETAIL_DATA detailData;
	HDEVINFO hDevInfo;
	int	MemberIndex = 0;
	int	DeviceIndex = 0;
	LONG DevInfo;
	ULONG Length = 0;
	ULONG Required;
	GUID HidGuid;
	
	CString serial;
	int counter = 0;

    ZeroMemory(&devInfoData, sizeof(devInfoData));
    devInfoData.cbSize = sizeof(devInfoData);

	HidD_GetHidGuid(&HidGuid);	

	hDevInfo = SetupDiGetClassDevs(&HidGuid, NULL, NULL, DIGCF_DEVICEINTERFACE | DIGCF_PRESENT);

	do{
		DevInfo = SetupDiEnumDeviceInterfaces(hDevInfo, NULL, &HidGuid, MemberIndex, &devInfoData);

		if (DevInfo != 0)
		{
			SetupDiGetDeviceInterfaceDetail(hDevInfo, &devInfoData, NULL, 0, &Length, NULL);

			detailData = (PSP_DEVICE_INTERFACE_DETAIL_DATA) malloc(Length);
			detailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

			SetupDiGetDeviceInterfaceDetail(hDevInfo, &devInfoData, detailData, Length, &Required, NULL);

			DeviceHandle = CreateFile(detailData->DevicePath, 0, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_NO_BUFFERING, NULL);

			Attributes.Size = sizeof(Attributes);
			HidD_GetAttributes (DeviceHandle, &Attributes);

			if(Attributes.VendorID == vendorID)
			{
				if(Attributes.ProductID == productID)
				{
					GetPreparsedData(DeviceHandle);

					/*Generate list of serials*/
					/*****************************************************************************/
					serial.SetString(GetSerialNumber(DeviceHandle));

					for(int i=0; i<32; i++)
						if((DevSerial[i] == serial) || (serial.GetLength() < 1))
							counter++;

					if(counter <= 0)
						DevSerial[MemberIndex].SetString(serial);

					/*****************************************************************************/

					DeviceIndex++;
				}
				else
					NULL;
			}
			else
			{
				CloseHandle(DeviceHandle);
			}
			counter = 0;
		free(detailData);
		}
		MemberIndex++;
	}while (DevInfo != NULL);

	SetupDiDestroyDeviceInfoList(hDevInfo);

	return 0;
}

/*Calculate with LSB and MSB a unsigned integer*/
int CAbsolutTiltDlg::ReadedData(void)
{
	ReadPipOne(HidHandle[0]);

	tData.x = abs(CalcPipeOne(PipeOne[2], PipeOne[1]) - 512);
	tData.y = abs(CalcPipeOne(PipeOne[4], PipeOne[3]) - 512);
	tData.z = abs(CalcPipeOne(PipeOne[6], PipeOne[5]) - 256);

	return 0;
}
void CAbsolutTiltDlg::OnTimer(UINT_PTR nIDEvent)
{
	if(nIDEvent == 101)
	{
		ReadedData();
		CString string;

		sXYWinkel.Format(_T("%.2f "), Winkel(tData.x/256, tData.y/256));

		GetDlgItem(IDC_XY_TILT)->SetWindowTextW(sXYWinkel);
		
		string.Format(_T("%d"), (int) tData.x);
		GetDlgItem(IDC_X_DATA)->SetWindowTextW(string);

		string.Format(_T("%d"), (int) tData.y);
		GetDlgItem(IDC_Y_DATA)->SetWindowTextW(string);
	
	}

	CDialog::OnTimer(nIDEvent);
}

void CAbsolutTiltDlg::OnCbnSelchangeDevicelist()
{
	//KillTimer(IDC_LOOPTIME1);

	cDevList.GetLBText(cDevList.GetCurSel(), sNowSerial);

	UpdateData(FALSE);

	ConnectToUSB(0x1113, 0x07C0, sNowSerial);

	SetTimer(IDC_LOOPTIME1, 100, NULL);
}