#include "stdafx.h"
#include "math.h"
#include "functions.h"

#define PI 3.14159265

short CalcMsbLsb(UCHAR lsb, UCHAR msb)
{
	short erg;
	short LSB, MSB, EXEC;
	short TEMP = 0x0000;

	EXEC = (msb & 0x80) << 8;
	EXEC = EXEC & 0x8000;

	/*Calculate negative values*/
	if(EXEC & 0x8000)
		EXEC = EXEC | 0x7C00;

	MSB = msb << 2;
	MSB = MSB & 0x03FC;
	LSB = (lsb & 0xC0) >> 6;
	LSB = LSB & 0x0003;

	erg = MSB | LSB | EXEC;

	return erg;
}

short CalcMsbLsb2(UCHAR lsb, UCHAR msb)
{
	short erg;
	short LSB, MSB;
	short TEMP = 0x0000;

	/*Calculate negative values*/

	MSB = msb << 2;
	MSB = MSB & 0x03FC;
	LSB = (lsb & 0xC0) >> 6;
	LSB = LSB & 0x0003;

	erg = MSB | LSB;

	return erg;
}

double FilterFIR(double input[16], double filter[16])
{
	int i;
	double sum = 0;

	for(i=0; i<16; i++) //FIR-steps
		sum += input[i]*filter[15-i]; //Berechnet die einzelnen Positionen
		
	/*Die eigentliche Formel zum Berechnen des FIR*/
	//output = input[0]*filter[15] + input[1]*filter[14] + input[2]*filter[13];

	return sum;
}

void ShiftInput15(double new_input, double shift[16])
{
	for(int k=0; k<16; k++)
		shift[k] = shift[k+1];

	shift[15] = new_input;
}

double Winkel(double x, double y)
{
	//a + b = c (Satz des Phytagoras)

	double c;
	double erg;

	c = sqrt((x*x) + (y*y));

	erg = asin(c) * 180 / PI;

	return erg;
}

double f(double x, int cx)
{
	return x * cos(30*x/cx) * sin(30*x/cx);
}

double f2( double x, int cx ) 
{ 
	return x * x /cx; 
}

/*
Funktionen, die Interessant sind:

-----------------
//int nStartX = 50;
 //   int nStartY = 300;
 //   double dSchrittlaenge = 50;

 //   CDC *pDC = GetDC();
 //   pDC->MoveTo(nStartX, nStartY);
 //   pDC->LineTo(nStartX + 700, nStartY);

 //   for(int i = 0; i < 700; i++)
 //       pDC->SetPixel(nStartX + i, nStartY + sin(PI*i/(2.0*dSchrittlaenge))*dSchrittlaenge, RGB(255,0,0));

-----------------

*/

/*Get program-path*/
CString GetPathString(void)
{
	char save[1024];
	int pos1 = 0;
	CString path;

	GetModuleFileNameW(NULL, (LPWCH) save, 1023);
	path.Format(_T("%s"), save);

	pos1 = path.ReverseFind('\\');

	path.SetString(path.Mid(0, pos1));

	return path;
}