// AnalyserDlg.cpp : Implementierungsdatei
//
#include "stdafx.h"
#include "Analyser.h"
#include "AnalyserDlg.h"
#include "math.h"
#include "functions.h"

#include <mmsystem.h> 

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAnalyserDlg-Dialogfeld

#define PI 3.145

#define CLR_BLACK	RGB(0, 0, 0)
#define CLR_RED		RGB(192, 0, 0)
#define CLR_GREEN	RGB(0, 100, 0)
#define CLR_GREY	RGB(192, 192,192)
#define CLR_BLUE	RGB(0, 0, 255)
#define CLR_ORANGE	RGB(240, 130, 30)
#define CLR_LIME	RGB(0, 200, 0)


CAnalyserDlg::CAnalyserDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAnalyserDlg::IDD, pParent)
	, iStep(0)
	, sNowSerial(_T(""))
	, iTime(0)
	, bLogRun(FALSE)
	, bDateiRun(FALSE)
	, bExistDatei(FALSE)
	, iDiv(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAnalyserDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DEVICELIST, cDevList);
	DDX_Control(pDX, IDC_SPIN1, cTimeSpin);
	DDX_Control(pDX, IDC_SPIN_DIVISOR, cDivSpin);
	DDX_Control(pDX, IDC_BUTTON_RECORD, cBRec);
	DDX_Control(pDX, IDC_BUTTON_STOP, cBStopp);
	DDX_Control(pDX, IDC_BUTTON1, cBPlay);
}

BEGIN_MESSAGE_MAP(CAnalyserDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(WM_DEVICECHANGE, &CAnalyserDlg::PlugInDevice) //Find devices automaticly
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CAnalyserDlg::OnBnClickedStart)
	ON_WM_CLOSE()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_DATEI_BEENDEN, &CAnalyserDlg::OnDateiBeenden)
	ON_COMMAND(ID_SPEICHERMEDIUM_DATEI, &CAnalyserDlg::OnSpeichermediumDatei)
	ON_WM_SETCURSOR()
		ON_CBN_SELCHANGE(IDC_DEVICELIST, &CAnalyserDlg::OnCbnSelchangeDevicelist)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN1, &CAnalyserDlg::OnDeltaposSpin1)
	ON_COMMAND(ID_DATENLOGGING_LOGGINGSTARTEN, &CAnalyserDlg::OnDatenloggingLoggingstarten)
	ON_COMMAND(ID_DATENLOGGING_LOGGINGSTOPPEN, &CAnalyserDlg::OnDatenloggingLoggingstoppen)
	ON_COMMAND(ID_DATEI_SCHLIESSEN, &CAnalyserDlg::OnDateiSchliessen)
	ON_WM_CTLCOLOR()
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_DIVISOR, &CAnalyserDlg::OnDeltaposSpinDivisor)
	ON_WM_RBUTTONDOWN()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_BUTTON_RECORD, &CAnalyserDlg::OnBnClickedButtonRecord)
	ON_BN_CLICKED(IDC_BUTTON_STOP, &CAnalyserDlg::OnBnClickedButtonStop)
END_MESSAGE_MAP()


// CAnalyserDlg-Meldungshandler

BOOL CAnalyserDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	/*Load menu*/
	//*****************************************************
	cMenu.LoadMenuW(IDR_MENU1);
	SetMenu(&cMenu);
	//*****************************************************

	/*Set all values to NULL*/
	/*****************************************************/
	SetAllZero();
	/*****************************************************/

	/*Set SpinButton*/
	/*****************************************************/
	iTime = 1;
	iStep = 1;

	cTimeSpin.SetBase(10);  //10 Dezimal; 16 Hexadezimal
	cTimeSpin.SetRange(1, 13);	
	cTimeSpin.SetPos(0);

	UpdateData(FALSE);

	GetDlgItem(IDC_TIME_EDIT)->SetWindowText(_T("8"));
	/*****************************************************/

	/*Set SpinButton*/
	/*****************************************************/
	iDiv = 4;

	cDivSpin.SetBase(10);  //10 Dezimal; 16 Hexadezimal
	cDivSpin.SetRange(2, 6);	
	cDivSpin.SetPos(4);

	UpdateData(FALSE);

	GetDlgItem(IDC_DIVISIOR_EDIT)->SetWindowText(_T("4"));
	/*****************************************************/


	/*Get all JW24F8 serials (from connected)*/
	/*****************************************************/
	EnumHidDevices(0x1113, 0x07C0);

	for(int i=0; i<15; i++)
		if(DevSerial[i] != _T(""))
			cDevList.AddString(DevSerial[i]);
	/*****************************************************/

	bLogRun = FALSE;
	bDateiRun = FALSE;
	bExistDatei = FALSE;

	IconRec = AfxGetApp()->LoadIcon( IDI_RECORD );
	IconStopp = AfxGetApp()->LoadIcon( IDI_STOPP );
	IconPlay = AfxGetApp()->LoadIcon( IDI_PLAY );

	cBRec.SetIcon(IconRec);
	cBStopp.SetIcon(IconStopp);
	cBPlay.SetIcon(IconPlay);

	CreateDrawground();
	
	return TRUE;
}

void CAnalyserDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);


		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;


		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}


	NewDrawFunction();	
}

HCURSOR CAnalyserDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

HBRUSH CAnalyserDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	return hbr;
}

void CAnalyserDlg::SetAllZero(void)
{
	for(int i=0; i<=875; i++)
	{
		tStore.x[i] = 0;
		tStore.y[i] = 0;
		tStore.z[i] = 0;
	}

	tRare.x = 0;
	tRare.y = 0;
	tRare.z = 0;

	tMiddleRare.x = 0;
	tMiddleRare.y = 0;
	tMiddleRare.z = 0;

}

LRESULT CAnalyserDlg::PlugInDevice(WPARAM wParam, LPARAM lParam)
{
	cDevList.ResetContent();

	for(int i=0; i<15; i++)
		DevSerial[i] = _T("");

	EnumHidDevices(0x1113, 0x07C0);

	for(int i=0; i<15; i++)
		if(DevSerial[i] != _T(""))
			cDevList.AddString(DevSerial[i]);
	
	return LRESULT();
}

void CAnalyserDlg::OnBnClickedStart()
{
	if(!sNowSerial.IsEmpty())
	{
		ConnectToUSB(0x1113, 0x07C0, sNowSerial);

		cMenu.EnableMenuItem(ID_SPEICHERMEDIUM_DATEI, MF_DISABLED | MF_GRAYED);
		cMenu.EnableMenuItem(ID_DATENLOGGING_LOGGINGSTOPPEN, MF_DISABLED | MF_GRAYED);
		cMenu.EnableMenuItem(ID_DATENLOGGING_LOGGINGSTARTEN, MF_DISABLED | MF_GRAYED);
		cMenu.EnableMenuItem(ID_DATEI_SCHLIESSEN, MF_DISABLED | MF_GRAYED);
		
		cDevList.EnableWindow(FALSE);
		cTimeSpin.EnableWindow(FALSE);

		UpdateData(FALSE);

		/*Multimedia-Timer BEGINN*/
		/*****************************************************/
		TIMECAPS tc;
		timeGetDevCaps(&tc, sizeof(TIMECAPS));

		DWORD resolution = min(max(tc.wPeriodMin, 0), tc.wPeriodMax);
		timeBeginPeriod(resolution);    

		idEvent = timeSetEvent(8, resolution, TimerFunction, (DWORD)this, TIME_PERIODIC); 
		/*****************************************************/

		iStep = 0;
		SetAllZero();

		GetDlgItem(IDC_BUTTON1)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_STOP)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_RECORD)->EnableWindow(FALSE);
	}
}

void CAnalyserDlg::OnBnClickedButtonRecord()
{
	if(!sNowSerial.IsEmpty())
	{
		CString path;
		CFileDialog cDialog(FALSE, 0, 0, 4|2, _T("Config (*.csv) |*.csv||"), 0, 0);

		if(LogFile.GetFileName() != _T(""))
		{
			LogFile.Close();
			LogFile.hFileNull;
		}

		if(cDialog.DoModal() == IDOK)
		{
			path.Format(_T("%s"), cDialog.GetPathName());
			LogFile.Open(path, CFile::modeCreate | CFile::modeWrite);

			cMenu.CheckMenuItem(ID_SPEICHERMEDIUM_DATEI, MF_CHECKED);
			cMenu.CheckMenuItem(ID_AUFZEICHNUNG_DATEI, MF_CHECKED);
			GetDlgItem(IDC_BUTTON1)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON_RECORD)->EnableWindow(FALSE);

			GetDlgItem(IDC_STATIC_LOGFILE)->SetWindowTextW(cDialog.GetFileName());
						
			bExistDatei = TRUE;

			if(bExistDatei == TRUE)
			{
				bDateiRun = TRUE;	
				cMenu.CheckMenuItem(ID_DATENLOGGING_LOGGINGSTARTEN, MF_CHECKED);
			}

			bLogRun = TRUE;	

			OnBnClickedStart();
		}
	}
	else
		MessageBox(_T("Please choose a device."), _T("Failure"), MB_OK);
}

void CAnalyserDlg::OnBnClickedButtonStop()
{
	timeKillEvent(idEvent);

	GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_STOP)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_RECORD)->EnableWindow(TRUE);

	cMenu.EnableMenuItem(ID_SPEICHERMEDIUM_DATEI, MF_ENABLED);
	cMenu.CheckMenuItem(ID_SPEICHERMEDIUM_DATEI, MF_UNCHECKED);
	cMenu.EnableMenuItem(ID_AUFZEICHNUNG_DATEI, MF_ENABLED);
	cMenu.CheckMenuItem(ID_AUFZEICHNUNG_DATEI, MF_UNCHECKED);
	cMenu.EnableMenuItem(ID_DATENLOGGING_LOGGINGSTOPPEN, MF_ENABLED);
	cMenu.EnableMenuItem(ID_DATENLOGGING_LOGGINGSTARTEN, MF_ENABLED);
	cMenu.CheckMenuItem(ID_DATENLOGGING_LOGGINGSTARTEN, MF_UNCHECKED);
	cMenu.EnableMenuItem(ID_DATEI_SCHLIESSEN, MF_ENABLED);

	cDevList.EnableWindow(TRUE);
	cTimeSpin.EnableWindow(TRUE);

	bExistDatei = FALSE;
	bLogRun = FALSE;	
	bDateiRun = FALSE;
}

void CALLBACK CAnalyserDlg::TimerFunction(UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
    CAnalyserDlg* obj = (CAnalyserDlg*)dwUser;
      obj->MMTimerHandler(wTimerID);
}  

void CAnalyserDlg::MMTimerHandler(UINT nIDEvent)
{
	ReadedData();
	
	if(bLogRun == TRUE)
	{
		if(bDateiRun == TRUE)
			WriteIntoFile(tRare.x, tRare.y, tRare.z, GetTimestamp());
	}


	if(iStep <= iTime)
	{
		tMiddleRare.x = tMiddleRare.x + tRare.x;
		tMiddleRare.y = tMiddleRare.y + tRare.y;
		tMiddleRare.z = tMiddleRare.z + tRare.z;
	}



	if(iStep == iTime)
	{
		iStep = 0;

		tStore.x[875] = (tMiddleRare.x/iTime)/iDiv;
		tStore.y[875] = (tMiddleRare.y/iTime)/iDiv;
		tStore.z[875] = (tMiddleRare.z/iTime)/iDiv;

		InvalidateRect(CRect(0, 0, 925, 650), FALSE);
	
		ShiftAll();

		tMiddleRare.x = 0;
		tMiddleRare.y = 0;
		tMiddleRare.z = 0;
	}

	if(iTime > 0)
		iStep++;
}

/*USB-Function: Get serialnumber from device*/
CString CAnalyserDlg::GetSerialNumber(HANDLE handle)
{
	WCHAR sn[32];
	CString	serial;
	
	memset(&sn, 0, 32);
	HidD_GetSerialNumberString(handle, &sn, 32); 

	serial.Format(_T("%s"), &sn[0]);
	return serial;
}

/*USB-Function: Get Handles from specified device*/
BOOL CAnalyserDlg::ConnectToUSB(ULONG productID, ULONG vendorID, CString serial)
{
	HIDD_ATTRIBUTES	Attributes;
	SP_DEVICE_INTERFACE_DATA devInfoData;
	PSP_DEVICE_INTERFACE_DETAIL_DATA detailData;
	HDEVINFO hDevInfo;
	int	MemberIndex = 0;
	int	DeviceIndex = 0;
	LONG DevInfo;
	ULONG Length = 0;
	ULONG Required;
	GUID HidGuid;

    ZeroMemory(&devInfoData, sizeof(devInfoData));
    devInfoData.cbSize = sizeof(devInfoData);

	HidD_GetHidGuid(&HidGuid);	

	hDevInfo = SetupDiGetClassDevsW(&HidGuid, NULL, NULL, DIGCF_DEVICEINTERFACE | DIGCF_PRESENT);

	do{
		DevInfo = SetupDiEnumDeviceInterfaces (hDevInfo, NULL, &HidGuid, MemberIndex, &devInfoData);

		if (DevInfo != 0)
		{
			SetupDiGetDeviceInterfaceDetailW(hDevInfo, &devInfoData, NULL, 0, &Length, NULL);

			detailData = (PSP_DEVICE_INTERFACE_DETAIL_DATA) malloc(Length);
			detailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

			SetupDiGetDeviceInterfaceDetailW(hDevInfo, &devInfoData, detailData, Length, &Required, NULL);

			DeviceHandle = CreateFileW(detailData->DevicePath, 0, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_NO_BUFFERING, NULL);

			Attributes.Size = sizeof(Attributes);
			HidD_GetAttributes (DeviceHandle, &Attributes);

			if(Attributes.VendorID == vendorID)
			{
				if(Attributes.ProductID == productID)
				{
					GetPreparsedData(DeviceHandle);

					if((GetSerialNumber(DeviceHandle) == serial) && (serial.GetLength() > 0))
					{
						HidHandle[DeviceIndex] = CreateFileW(detailData->DevicePath, 
															GENERIC_WRITE | GENERIC_READ, 
															FILE_SHARE_READ|FILE_SHARE_WRITE, 
															NULL,
															OPEN_EXISTING, 
															FILE_FLAG_NO_BUFFERING, 
															NULL);
						
						DeviceIndex++;
					}
				}
				else
					NULL;
			}
			else
			{
				CloseHandle(DeviceHandle);
			}
		free(detailData);
		}
		MemberIndex++;
	}while (DevInfo != NULL);

	SetupDiDestroyDeviceInfoList(hDevInfo);

	return 0;
}

/*USB-Function: Get informations from device*/
HIDP_CAPS CAnalyserDlg::GetPreparsedData(HANDLE handle)
{
	PHIDP_PREPARSED_DATA PreparsedData;

	HidD_GetPreparsedData(handle, &PreparsedData);
	HidP_GetCaps(PreparsedData, &Capabilities);
	HidD_FreePreparsedData(PreparsedData);

	return Capabilities;
}

/*USB-Function: Read data from interface 0*/
UCHAR CAnalyserDlg::ReadPipOne(HANDLE handle)
{
	DWORD NumberOfBytesRead = 0;

	memset(&PipeOne, 0, Capabilities.InputReportByteLength+1);
	PipeOne[0] = 0x00;
	
	ReadFile(handle, &PipeOne, Capabilities.InputReportByteLength, &NumberOfBytesRead, NULL);
	return 0;
}

short CAnalyserDlg::CalcPipeOne(UCHAR lsb, UCHAR msb)
{
	short erg;
	short LSB, MSB;

	MSB = msb;
	MSB = MSB & 0x00FF;
	LSB = (lsb & 0x03) << 8; // *256
	LSB = LSB & 0x0300;

	erg = MSB | LSB ;

	return erg;
}

/*USB-Function: Enumerate all specified devices an store their serialnumber*/
int CAnalyserDlg::EnumHidDevices(ULONG productID, ULONG vendorID)
{
	HIDD_ATTRIBUTES	Attributes;
	SP_DEVICE_INTERFACE_DATA devInfoData;
	PSP_DEVICE_INTERFACE_DETAIL_DATA detailData;
	HDEVINFO hDevInfo;
	int	MemberIndex = 0;
	int	DeviceIndex = 0;
	LONG DevInfo;
	ULONG Length = 0;
	ULONG Required;
	GUID HidGuid;
	
	CString serial;
	int counter = 0;

    ZeroMemory(&devInfoData, sizeof(devInfoData));
    devInfoData.cbSize = sizeof(devInfoData);

	HidD_GetHidGuid(&HidGuid);	

	hDevInfo = SetupDiGetClassDevsW(&HidGuid, NULL, NULL, DIGCF_DEVICEINTERFACE | DIGCF_PRESENT);

	do{
		DevInfo = SetupDiEnumDeviceInterfaces (hDevInfo, NULL, &HidGuid, MemberIndex, &devInfoData);

		if (DevInfo != 0)
		{
			SetupDiGetDeviceInterfaceDetailW(hDevInfo, &devInfoData, NULL, 0, &Length, NULL);

			detailData = (PSP_DEVICE_INTERFACE_DETAIL_DATA) malloc(Length);
			detailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

			SetupDiGetDeviceInterfaceDetailW(hDevInfo, &devInfoData, detailData, Length, &Required, NULL);

			DeviceHandle = CreateFileW(detailData->DevicePath, 0, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_NO_BUFFERING, NULL);

			Attributes.Size = sizeof(Attributes);
			HidD_GetAttributes (DeviceHandle, &Attributes);

			if(Attributes.VendorID == vendorID)
			{
				if(Attributes.ProductID == productID)
				{
					GetPreparsedData(DeviceHandle);

					/*Generate list of serials*/
					/*****************************************************************************/
					serial.SetString(GetSerialNumber(DeviceHandle));

					for(int i=0; i<32; i++)
						if((DevSerial[i] == serial) || (serial.GetLength() < 1))
							counter++;

					if(counter <= 0)
						DevSerial[MemberIndex].SetString(serial);

					/*****************************************************************************/

					DeviceIndex++;
				}
				else
					NULL;
			}
			else
			{
				CloseHandle(DeviceHandle);
			}
			counter = 0;
		free(detailData);
		}
		MemberIndex++;
	}while (DevInfo != NULL);

	SetupDiDestroyDeviceInfoList(hDevInfo);

	return 0;
}

void CAnalyserDlg::OnClose()
{
	if(LogFile.GetFileName() != _T(""))
		LogFile.Close();

	timeKillEvent(idEvent);

	CDialog::OnClose();
}

void CAnalyserDlg::CreateDrawground(void)
{
	bDC = this->GetDC();
	nDC.CreateCompatibleDC(bDC);
    nBitmap.CreateCompatibleBitmap(bDC, 925, 650);
	nBrush.CreateSolidBrush(CLR_BLACK);
	
	pOldBitmap = nDC.SelectObject(&nBitmap);
	pOldBrush = nDC.SelectObject(&nBrush); 
}

void CAnalyserDlg::NewDrawFunction(void)
{
	CPen cPen;
	CFont cFont;
	CString string;
	
	//Create backgroundcolor for bitmap
	//**************************************************************************
	nDC.FillSolidRect(CRect(0, 0, 950, 650), RGB(255, 255, 255)); //Zeichne Background ohne Brush
	//**************************************************************************

	/*Draw timeline*/
	//**************************************************************************
	cFont.CreateFontW(10, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, DEFAULT_CHARSET, OUT_CHARACTER_PRECIS,CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, _T("Arial"));
	nDC.SelectObject(&cFont);
	cPen.CreatePen(PS_SOLID, 1, CLR_GREY);
	nDC.SelectObject(&cPen);
	int j = 0;

	for(int i=875; i>=0; i=i-(125/iTime))
	{
		nDC.MoveTo(i, 0);
		nDC.LineTo(i, 625);

		if(j>0)
		{
			string.Format(_T("%d"), j);
			nDC.TextOutW(i + 5, 160, string, string.GetLength());
			nDC.TextOutW(i + 5, 320, string, string.GetLength());
			nDC.TextOutW(i + 5, 480, string, string.GetLength());
		}
		j++;
	}

	nDC.TextOutW(880, 160, _T("Sec"), 3);
	nDC.TextOutW(880 + 5, 320, _T("Sec"), 3);
	nDC.TextOutW(880 + 5, 480, _T("Sec"), 3);

 
	cPen.DeleteObject();
	cFont.DeleteObject();
	
	//**************************************************************************

	//Draw Frame
	//**************************************************************************
	nDC.FrameRect(CRect(0, 0, 925, 650), &nBrush); //Zeichne Rahmen
	//**************************************************************************

	/*Draw vertical for height*/
	//**************************************************************************
	cPen.CreatePen(PS_SOLID, 1, CLR_BLACK);
	nDC.SelectObject(&cPen);

	nDC.MoveTo(875, 0);
	nDC.LineTo(875, 625);

	nDC.MoveTo(0, 625);
	nDC.LineTo(875, 625);

	cPen.DeleteObject();
	//**************************************************************************

	/*Draw Baselines*/
	//**************************************************************************
	cPen.CreatePen(PS_SOLID, 1, CLR_BLACK);
	nDC.SelectObject(&cPen);

	nDC.MoveTo(0, 160);
	nDC.LineTo(875, 160);

	nDC.MoveTo(0, 320);
	nDC.LineTo(875, 320);

	nDC.MoveTo(0, 480);
	nDC.LineTo(875, 480);
 
	cPen.DeleteObject();
	//**************************************************************************

	//Draw graphs
	//**************************************************************************
	cPen.CreatePen(PS_SOLID, 1, CLR_RED);
	nDC.SelectObject(&cPen);

	int BackUp[3];

	for(int i=0; i<3; i++)
		BackUp[i] = 0;

	for(int i=0; i<875; i++)
	{
		/*Basisdaten*/
		nDC.MoveTo(i, 160 - BackUp[0]);
		nDC.LineTo(i+1, 160 - tStore.x[i]);
		BackUp[0] = tStore.x[i];

		/*Basisdaten*/
		nDC.MoveTo(i, 320 - BackUp[1]);
		nDC.LineTo(i+1, 320 - tStore.y[i]);
		BackUp[1] = tStore.y[i];

		/*Basisdaten*/
		nDC.MoveTo(i, 480 - BackUp[2]);
		nDC.LineTo(i+1, 480 - tStore.z[i]);
		BackUp[2] = tStore.z[i];

		cPen.DeleteObject();
	}

	//**************************************************************************

	/*Draw line with values*/
	//**************************************************************************

	if((lMouse.lock == TRUE) && (lMouse.x > 0) && (lMouse.x < 875) && (lMouse.y > 0) && (lMouse.y < 625))
	{
		cFont.CreateFontW(16, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, DEFAULT_CHARSET, OUT_CHARACTER_PRECIS,CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, _T("Arial"));
		nDC.SelectObject(&cFont);

		cPen.CreatePen(PS_SOLID, 1, CLR_BLUE);
		nDC.SelectObject(&cPen);

		nDC.MoveTo(lMouse.x-5, 0);
		nDC.LineTo(lMouse.x-5, 650);

		nDC.MoveTo(0, 160 - tStore.x[lMouse.x-5]);
		nDC.LineTo(875, 160 - tStore.x[lMouse.x-5]);

		nDC.MoveTo(0, 320 - tStore.y[lMouse.x-5]);
		nDC.LineTo(875, 320 - tStore.y[lMouse.x-5]);

		nDC.MoveTo(0, 480 - tStore.z[lMouse.x-5]);
		nDC.LineTo(875, 480 - tStore.z[lMouse.x-5]);


		string.Format(_T("Data: %d"), (tStore.x[lMouse.x-5]*iDiv));
		nDC.TextOutW(lMouse.x + 5, 50, string, string.GetLength());

		string.Format(_T("Data: %d"), (tStore.y[lMouse.x-5]*iDiv));
		nDC.TextOutW(lMouse.x + 5, 250, string, string.GetLength());

		string.Format(_T("Data: %d"), (tStore.z[lMouse.x-5]*iDiv));
		nDC.TextOutW(lMouse.x + 5, 450, string, string.GetLength());

		cPen.DeleteObject();
		cFont.DeleteObject();
	}


	if((rMouse.lock == TRUE) && (rMouse.x > 0) && (rMouse.x < 875) && (rMouse.y > 0) && (rMouse.y < 625))
	{
		cFont.CreateFontW(16, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, DEFAULT_CHARSET, OUT_CHARACTER_PRECIS,CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, _T("Arial"));
		nDC.SelectObject(&cFont);

		cPen.CreatePen(PS_SOLID, 1, CLR_LIME);
		nDC.SelectObject(&cPen);

		nDC.MoveTo(rMouse.x-5, 0);
		nDC.LineTo(rMouse.x-5, 650);

		nDC.MoveTo(0, 160 - tStore.x[rMouse.x-5]);
		nDC.LineTo(875, 160 - tStore.x[rMouse.x-5]);

		nDC.MoveTo(0, 320 - tStore.y[rMouse.x-5]);
		nDC.LineTo(875, 320 - tStore.y[rMouse.x-5]);

		nDC.MoveTo(0, 480 - tStore.z[rMouse.x-5]);
		nDC.LineTo(875, 480 - tStore.z[rMouse.x-5]);


		string.Format(_T("Data: %d"), (tStore.x[rMouse.x-5]*iDiv));
		nDC.TextOutW(rMouse.x + 5, 75, string, string.GetLength());

		string.Format(_T("Data: %d"), (tStore.y[rMouse.x-5]*iDiv));
		nDC.TextOutW(rMouse.x + 5, 275, string, string.GetLength());

		string.Format(_T("Data: %d"), (tStore.z[rMouse.x-5]*iDiv));
		nDC.TextOutW(rMouse.x + 5, 475, string, string.GetLength());

		cPen.DeleteObject();
		cFont.DeleteObject();
	}

	if((lMouse.lock == TRUE ) && (rMouse.lock == TRUE))
	{
		string.Format(_T("Range: %d"), abs((rMouse.x - lMouse.x)*(iTime*8)));
		nDC.TextOutW(rMouse.x + 5, 90, string, string.GetLength());

	}

	//**************************************************************************


	/*Draw Baselines*/
	//**************************************************************************
	cPen.CreatePen(PS_SOLID, 1, CLR_BLACK);
	nDC.SelectObject(&cPen);

	nDC.MoveTo(0, 160);
	nDC.LineTo(875, 160);

	nDC.MoveTo(0, 320);
	nDC.LineTo(875, 320);

	nDC.MoveTo(0, 480);
	nDC.LineTo(875, 480);
 
	cPen.DeleteObject();
	//**************************************************************************


	/*Draw Axis*/
	//**************************************************************************
	cFont.CreateFontW(24, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, DEFAULT_CHARSET, OUT_CHARACTER_PRECIS,CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, _T("Arial"));
	nDC.SelectObject(&cFont);
	nDC.TextOutW(900, 160, _T("X"), 1);
	nDC.TextOutW(900, 320, _T("Y"), 1);
	nDC.TextOutW(900, 480, _T("Z"), 1);
	cFont.DeleteObject();
	//**************************************************************************


	bDC->BitBlt(5, 5, 925, 650, &nDC, 0, 0, SRCCOPY);
}

/*Calculate with LSB and MSB a unsigned integer (with abs())*/
int CAnalyserDlg::ReadedData(void)
{
	ReadPipOne(HidHandle[0]);
	tRare.x = (CalcPipeOne(PipeOne[2], PipeOne[1]) - 512);
	tRare.y = (CalcPipeOne(PipeOne[4], PipeOne[3]) - 512);
	tRare.z = (CalcPipeOne(PipeOne[6], PipeOne[5]) - 256);

	return 0;
}
void CAnalyserDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	//POINT pos;
	//GetCursorPos(&pos);
	//TRACE("Pos 1: %d/%d\n",pos.x,pos.y);
	//TRACE("Pos 2: %d/%d\n",point.x,point.y);

	lMouse.x = point.x;
	lMouse.y = point.y;
	lMouse.lock = TRUE;

	Invalidate(FALSE);

	CDialog::OnLButtonDown(nFlags, point);
}

void CAnalyserDlg::OnRButtonDown(UINT nFlags, CPoint point)
{
	rMouse.x = point.x;
	rMouse.y = point.y;
	rMouse.lock = TRUE;

	Invalidate(FALSE);

	CDialog::OnRButtonDown(nFlags, point);
}

/*Creates a special mousecursor for better pointing*/
void CAnalyserDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	//Value Description
	//IDC_APPSTARTING Standard arrow and small hourglass
	//IDC_ARROW Standard arrow
	//IDC_CROSS Crosshair
	//IDC_HAND Hand
	//IDC_HELP Arrow and question mark
	//IDC_ICON Obsolete
	//IDC_NO Slashed circle
	//IDC_SIZE Obsolete; use IDC_SIZEALL
	//IDC_SIZEALL Four-pointed arrow pointing north, south, east, and west
	//IDC_SIZENESW Double-pointed arrow pointing northeast and southwest
	//IDC_SIZENS Double-pointed arrow pointing north and south
	//IDC_SIZENWSE Double-pointed arrow pointing northwest and southeast
	//IDC_SIZEWE Double-pointed arrow pointing west and east
	//IDC_UPARROW Vertical arrow
	//IDC_WAIT Hourglass 

	if((point.x > 5) && (point.x < 900))
		if((point.y > 5) && (point.y < 650))
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_CROSS));
	else
		::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));


	CDialog::OnMouseMove(nFlags, point);
}


/*Shift the data for grafical display*/
void CAnalyserDlg::ShiftAll(void)
{
	int temp[3];
	int store[3];

	temp[0] = tStore.x[875];
	temp[1] = tStore.y[875];
	temp[2] = tStore.z[875];

	for(int i=874; i>=0; i--)
	{
		store[0] = tStore.x[i-1];
		tStore.x[i-1] = temp[0];
		temp[0] = store[0];

		store[1] = tStore.y[i-1];
		tStore.y[i-1] = temp[1];
		temp[1] = store[1];

		store[2] = tStore.z[i-1];
		tStore.z[i-1] = temp[2];
		temp[2] = store[2];
	}
}

void CAnalyserDlg::OnDateiBeenden()
{
	if(LogFile.GetFileName() != _T(""))
		LogFile.Close();

	OnOK();
}

void CAnalyserDlg::WriteIntoFile(int x, int y, int z, int time)
{
	CString value;

	value.Format(_T("%d;%d;%d;%d\r\n"), time, x, y, z);

	LogFile.Write((LPCTSTR) value, value.GetLength()*sizeof(TCHAR));
}

void CAnalyserDlg::OnSpeichermediumDatei()
{
	CString path;
	CFileDialog cDialog(FALSE, 0, 0, 4|2, _T("Config (*.csv) |*.csv||"), 0, 0);

	if(cDialog.DoModal() == IDOK)
	{
		path.Format(_T("%s"), cDialog.GetPathName());
		LogFile.Open(path, CFile::modeCreate | CFile::modeWrite);

		cMenu.CheckMenuItem(ID_SPEICHERMEDIUM_DATEI, MF_CHECKED);
		cMenu.CheckMenuItem(ID_AUFZEICHNUNG_DATEI, MF_CHECKED);
		
		bExistDatei = TRUE;
	}
}

void CAnalyserDlg::OnDateiSchliessen()
{
	if(LogFile.GetFileName() != _T(""))
	{
		LogFile.Close();
	}
		cMenu.CheckMenuItem(ID_SPEICHERMEDIUM_DATEI, MF_UNCHECKED);
		cMenu.CheckMenuItem(ID_AUFZEICHNUNG_DATEI, MF_UNCHECKED);
		bExistDatei = FALSE;
		OnDatenloggingLoggingstoppen();
}

/*Create a timestamp from 1.1.1970 up to now in seconds*/
int CAnalyserDlg::GetTimestamp(void)
{
	CString string;
	CTime cTime = CTime::GetCurrentTime();
	
	string.Format(_T("%d"), cTime.GetTickCount());

	return _wtoi(string);
}


void CAnalyserDlg::OnCbnSelchangeDevicelist()
{
	cDevList.GetLBText(cDevList.GetCurSel(), sNowSerial);
}

/*Set the timer-intervall from 10ms up to 500ms in 10-steps*/
void CAnalyserDlg::OnDeltaposSpin1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	
	CString string;
	iTime = pNMUpDown->iPos;
	string.Format(_T("%d"), iTime*8);


	GetDlgItem(IDC_TIME_EDIT)->SetWindowText(string);

	Invalidate(FALSE);

	*pResult = 0;
}

void CAnalyserDlg::OnDatenloggingLoggingstarten()
{
	if(bExistDatei == TRUE)
	{
		bDateiRun = TRUE;	
		cMenu.CheckMenuItem(ID_DATENLOGGING_LOGGINGSTARTEN, MF_CHECKED);
	}

	bLogRun = TRUE;	
}

void CAnalyserDlg::OnDatenloggingLoggingstoppen()
{
	bDateiRun = FALSE;
	bLogRun = FALSE;

	cMenu.CheckMenuItem(ID_DATENLOGGING_LOGGINGSTARTEN, MF_UNCHECKED);
}



void CAnalyserDlg::OnDeltaposSpinDivisor(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

	CString string;
	iDiv = pNMUpDown->iPos;
	string.Format(_T("%d"), iDiv);


	GetDlgItem(IDC_DIVISIOR_EDIT)->SetWindowText(string);

	Invalidate(FALSE);

	*pResult = 0;
}
