// AnalyserDlg.h : Headerdatei
//

#pragma once

extern "C" { 
#include "hidsdi.h" 
#include "setupapi.h"
}

// CAnalyserDlg-Dialogfeld
#include "afxwin.h"
#include "afxcmn.h"
#include "afxext.h"

#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"hid.lib")
#pragma comment(lib,"setupapi.lib")


class CAnalyserDlg : public CDialog
{
// Konstruktion
public:
	CAnalyserDlg(CWnd* pParent = NULL);	// Standardkonstruktor

// Dialogfelddaten
	enum { IDD = IDD_ANALYSER_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung


// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Funktionen fr die Meldungstabellen
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

protected:
	CBitmap nBitmap;
	CDC* bDC;
	CDC nDC;
	CBrush* pOldBrush;
	CBitmap* pOldBitmap;
	CBrush nBrush;

private:
	static void CALLBACK TimerFunction(UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2); 

public:
	afx_msg LRESULT PlugInDevice(WPARAM wParam, LPARAM lParam);
	afx_msg void OnBnClickedStart();

	HANDLE DeviceHandle;
	HANDLE HidHandle[2];
	HIDP_CAPS Capabilities;
	UCHAR PipeOne[10];

	BOOL ConnectToUSB(ULONG productID, ULONG vendorID, CString serial);
	HIDP_CAPS GetPreparsedData(HANDLE handle);
	CString GetSerialNumber(HANDLE handle);
	int EnumHidDevices(ULONG productID, ULONG vendorID);
	UCHAR ReadPipOne(HANDLE handle);
	short CalcPipeOne(UCHAR lsb, UCHAR msb);

	typedef struct DATASTRUCT
	{
		int x;
		int y;
		int z;
	} DATASTRUCT;

	typedef struct STORE
	{
		int x[875];
		int y[875];
		int z[875];
	} STORE;


	typedef struct MOUSELOCK
	{
		int x;
		int y;
		bool lock;

	}MOUSELOCK;

	DATASTRUCT tRare;
	DATASTRUCT tMiddleRare;
 
	STORE tStore;
	STORE tGfx;

	MOUSELOCK lMouse;
	MOUSELOCK rMouse;


	CMenu cMenu;
	int iStep;
	int iTime;

	CFile LogFile;

	BOOL bExistDatei;
	BOOL bDateiRun;
	BOOL bLogRun;


	CString DevSerial[32];
	CString sNowSerial;
	CComboBox cDevList;
	CSpinButtonCtrl cTimeSpin;

	UINT idEvent;

	void ShiftAll(void);
	//void DrawFunction(void);
	int ReadedData(void);

	afx_msg void OnClose();
	afx_msg void OnAnzeigeFiltereinstellungen();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnDateiBeenden();
	afx_msg void OnCbnSelchangeDevicelist();
	afx_msg void OnDeltaposSpin1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnSpeichermediumDatei();
	afx_msg void OnChildActivate();
	afx_msg void OnDatenloggingLoggingstarten();
	afx_msg void OnDatenloggingLoggingstoppen();
	afx_msg void OnDateiSchliessen();

	void WriteIntoFile(int x, int y, int z, int time);
	int GetTimestamp(void);


	void MMTimerHandler(UINT nIDEvent);

	void NewDrawFunction(void);
	void CreateDrawground(void);
	void SetAllZero(void);
	int iDiv;
	afx_msg void OnDeltaposSpinDivisor(NMHDR *pNMHDR, LRESULT *pResult);
	CSpinButtonCtrl cDivSpin;
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);

	CButton cBRec;
	CButton cBStopp;
	CButton cBPlay;
	HICON IconRec;
	HICON IconStopp;
	HICON IconPlay;

	HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);

	afx_msg void OnBnClickedButtonRecord();

	afx_msg void OnBnClickedButtonStop();
};
