// KioskprotectDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Kioskprotect.h"
#include "KioskprotectDlg.h"
#include "math.h"
#include "functions.h"
#include <mmsystem.h> 

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CKioskprotectDlg-Dialogfeld


CKioskprotectDlg::CKioskprotectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKioskprotectDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CKioskprotectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EVENTLIST, cEvent);
	DDX_Control(pDX, IDC_SPIN1, cSpin);
	DDX_Control(pDX, IDC_VISUAL_EFFECT, cStaticBitmap);
}

BEGIN_MESSAGE_MAP(CKioskprotectDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_DATEI_START, &CKioskprotectDlg::OnDateiStart)
	ON_WM_CLOSE()
	ON_WM_CTLCOLOR()
	ON_COMMAND(ID_DATEI_BEENDEN, &CKioskprotectDlg::OnDateiBeenden)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN1, &CKioskprotectDlg::OnDeltaposSpin1)
END_MESSAGE_MAP()


// CKioskprotectDlg-Meldungshandler

BOOL CKioskprotectDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);


	
	/*Set all varables to ZERO*/
	hid.HidHandle[0] = 0;

	for(int i=0; i<16; i++)
	{
		tFilter.x[i] = 0;
		tFilter.y[i] = 0;
		tFilter.z[i] = 0;
	}

	tData.x = 0;
	tData.y = 0;
	tData.z = 0;

	tBuffer.x = 0;
	tBuffer.y = 0;
	tBuffer.z = 0;

	for(int i=0; i<10; i++)
	{
		dBuffer.x[i] = 0;
		dBuffer.y[i] = 0;
		dBuffer.z[i] = 0;
	}
	
	/*Setup for font*/
	cFont.CreateFontW(20, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, DEFAULT_CHARSET, OUT_CHARACTER_PRECIS,CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, _T("Arial"));
	sPath.Format(_T("%s\\boing_1.wav"), GetPathString());


	/*Set filtersetup*/
	/*DOWN PASS*/
	tTiefpass[0] = 0.02;
	tTiefpass[1] = 0.08;
	tTiefpass[2] = 0.03;
	tTiefpass[3] = 0.00;
	tTiefpass[4] = -0.07;
	tTiefpass[5] = -0.16;
	tTiefpass[6] = -0.22;
	tTiefpass[7] = -0.25;
	tTiefpass[8] = -0.22;
	tTiefpass[9] = -0.16;
	tTiefpass[10] = -0.07;
	tTiefpass[11] = 0.00;
	tTiefpass[12] = 0.03;
	tTiefpass[13] = 0.08;
	tTiefpass[14] = 0.02;
	tTiefpass[15] = 0.00;

	/*HIGH PASS*/
	tHochpass[0] = 0.02;
	tHochpass[1] = -0.08;
	tHochpass[2] = 0.03;
	tHochpass[3] = -0.00;
	tHochpass[4] = -0.07;
	tHochpass[5] = 0.16;
	tHochpass[6] = -0.22;
	tHochpass[7] = 0.25;
	tHochpass[8] = -0.22;
	tHochpass[9] = 0.16;
	tHochpass[10] = -0.07;
	tHochpass[11] = -0.00;
	tHochpass[12] = 0.03;
	tHochpass[13] = -0.08;
	tHochpass[14] = 0.02;
	tHochpass[15] = 0.00;
	/*********************/


	bAlarm = FALSE;  //Status: Alarm
	
	/*Set counter for timeing*/
	iTiltTime = 0;
	iMoveTime = 0;
	iHitTime = 0;

	/*Counter for checks*/
	iCount = 0;
	iCount2 = 0;
	iCount3 = 0;

	/*Setup cSpin*/
	cSpin.SetBase(10);  //10 Dezimal; 16 Hexadezimal
	cSpin.SetRange(5, 80);	
	cSpin.SetPos(10);
	dDegree = 10;

	GetDlgItem(IDC_STATIC_DEGREE)->SetWindowTextW(_T("10"));


	return TRUE;
}

void CKioskprotectDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}

	GetDlgItem(IDC_STATIC_X)->SetFont(&cFont);
	GetDlgItem(IDC_STATIC_X2)->SetFont(&cFont);
	GetDlgItem(IDC_STATIC_X3)->SetFont(&cFont);
	GetDlgItem(IDC_STATIC_Y)->SetFont(&cFont);
	GetDlgItem(IDC_STATIC_Y2)->SetFont(&cFont);
	GetDlgItem(IDC_STATIC_Y3)->SetFont(&cFont);
	GetDlgItem(IDC_STATIC_Z)->SetFont(&cFont);
	GetDlgItem(IDC_STATIC_Z2)->SetFont(&cFont);
	GetDlgItem(IDC_STATIC_Z3)->SetFont(&cFont);

	GetDlgItem(IDC_STATIC_TILT)->SetFont(&cFont);
	GetDlgItem(IDC_STATIC_TILT2)->SetFont(&cFont);

	GetDlgItem(IDC_STATIC_XT)->SetFont(&cFont);
	GetDlgItem(IDC_STATIC_YT)->SetFont(&cFont);
	GetDlgItem(IDC_STATIC_ZT)->SetFont(&cFont);
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CKioskprotectDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CKioskprotectDlg::OnDateiStart()
{
	hid.Serial.SetString(_T("00000000")); //Set string to JW24F8 with serial "00000000"

	/*Conenct to JW24F8 ... function will be found in functions_usb.cpp*/
	ConnectToUSB2(JW24F8_PID, JW24F8_VID, hid.HidHandle, hid.Serial, hid.Capabilities);

	if(hid.HidHandle[0] != NULL) //Connect success?
	{
		/*Multimedia-Timer BEGINN*/
		/*****************************************************/
		TIMECAPS tc;
		timeGetDevCaps(&tc, sizeof(TIMECAPS));

		DWORD resolution = min(max(tc.wPeriodMin, 0), tc.wPeriodMax);
		timeBeginPeriod(resolution);    

		idEvent = timeSetEvent(8, resolution, TimerFunction, (DWORD)this, TIME_PERIODIC); 
		/*****************************************************/
	}
}

/*For Multimedia-Timer*/
void CALLBACK CKioskprotectDlg::TimerFunction(UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
    CKioskprotectDlg* obj = (CKioskprotectDlg*)dwUser;
      obj->MMTimerHandler(wTimerID);
}  

/*For Multimedia-Timer: Main funcion*/
void CKioskprotectDlg::MMTimerHandler(UINT nIDEvent)
{
	CString string, path, temp;
	double winkel = 0; //Degree raw data
	double dWinkel = 0; //Degree filter data (down pass)

	ReadedData();

	//tBuffer contains buffer (for FIR-Function)
	ShiftInput15(abs(tBuffer.x), tFilter.x);
	ShiftInput15(abs(tBuffer.y), tFilter.y);
	ShiftInput15(abs(tBuffer.z), tFilter.z);

	//Value for down pass (Tilt, Hit-Detect "Hand", Movement)
	dsTP.x = (FilterFIR(tFilter.x, tTiefpass));
	dsTP.y = (FilterFIR(tFilter.y, tTiefpass));
	dsTP.z = (FilterFIR(tFilter.z, tTiefpass));

	//Value for high pass (Hit-Detect "Hammer")
	dsHP.x = (FilterFIR(tFilter.x, tHochpass));
	dsHP.y = (FilterFIR(tFilter.y, tHochpass));
	dsHP.z = (FilterFIR(tFilter.z, tHochpass));

	/*Calc degree for tilt detection*/
	dWinkel = Winkel(abs(tBuffer.x) / 256, abs(tBuffer.y) / 256);
	winkel = Winkel(abs(dsTP.x) / 256, abs(dsTP.y) / 256);


	/*What happen if tilt reach setup?*/
	if((dWinkel >= 0) && (dWinkel <= 90))
		string.Format(_T("%.0f "), dWinkel);
	else
		string.SetString(_T("90"));

	GetDlgItem(IDC_STATIC_TILT)->SetWindowText(string);

	if((winkel >= 0) && (winkel <= 90))
		string.Format(_T("%.0f "), winkel);
	else
		string.SetString(_T("90"));

	GetDlgItem(IDC_STATIC_TILT2)->SetWindowText(string);


	/*Show data from axis*/
	string.Format(_T("%.0f"), abs(dsTP.x));
	GetDlgItem(IDC_STATIC_X)->SetWindowText(string);

	string.Format(_T("%.0f"), abs(dsTP.y));
	GetDlgItem(IDC_STATIC_Y)->SetWindowText(string);

	string.Format(_T("%.0f"), abs(dsTP.z));
	GetDlgItem(IDC_STATIC_Z)->SetWindowText(string);


	/*Show data from axis*/
	string.Format(_T("%.0f"), abs(dsHP.x));
	GetDlgItem(IDC_STATIC_X2)->SetWindowText(string);

	string.Format(_T("%.0f"), abs(dsHP.y));
	GetDlgItem(IDC_STATIC_Y2)->SetWindowText(string);

	string.Format(_T("%.0f"), abs(dsHP.z));
	GetDlgItem(IDC_STATIC_Z2)->SetWindowText(string);



	/*Show data from axis*/
	string.Format(_T("%.0f"), abs(tBuffer.x));
	GetDlgItem(IDC_STATIC_X3)->SetWindowText(string);

	string.Format(_T("%.0f"), abs(tBuffer.y));
	GetDlgItem(IDC_STATIC_Y3)->SetWindowText(string);

	string.Format(_T("%.0f"), abs(tBuffer.z));
	GetDlgItem(IDC_STATIC_Z3)->SetWindowText(string);

	/*In this sample only one alert will be detect at the same time*/

	//Detect button-event
	if(tBuffer.b & 0x80)
	{
	//	bDoor = TRUE;
	//	bStatus = TRUE;

		temp.Format(_T("%s Digita Input"), GetDateCode());
		cEvent.InsertString(0, temp);
	}

		/*Check the tilt; include the Z-Axis*/
		if((winkel >= dDegree) && (bAlarm == FALSE) && (abs(dsTP.z) >= 4)) // >=4 for ignore "lift up"
		{
			iTiltTime++;

			if(iTiltTime == 30) //30 Steps = 250ms for detect real "tilt" not "run against it"
			{
				bAlarm = TRUE;
				
				//PlaySoundW(sPath, NULL, SND_ASYNC);
				temp.Format(_T("%s Tilt"), GetDateCode());
				cEvent.InsertString(0, temp);	
				cBitmap.LoadBitmapW(IDB_BITMAP2);
				cStaticBitmap.SetBitmap(cBitmap);
				cBitmap.DeleteObject();
			}
		}
		/*check the tilt; count up to reset the alert*/
		if((bAlarm == TRUE) && (winkel <= dDegree) && (abs(dsTP.z) < 4))
			iCount++;
		
		/*detect movement of the Z-Axis ("lift up")*/
		if((dsTP.z <= -30) && (dsTP.z >= -100) && (winkel <= dDegree) && (bAlarm == FALSE))
		{
			iMoveTime++;

			if(iMoveTime == 15)
			{
				bAlarm = TRUE;
				//PlaySoundW(sPath, NULL, SND_ASYNC);
				temp.Format(_T("%s Lift Up"), GetDateCode());
				cEvent.InsertString(0, temp);
				cBitmap.LoadBitmapW(IDB_BITMAP2);
				cStaticBitmap.SetBitmap(cBitmap);
				cBitmap.DeleteObject();
			}
		}
		/*check the z-axis for movement; count up to reset the alert*/
		if((abs(dsTP.z) < 10) && (bAlarm == TRUE) && (iMoveTime > 0))
			iCount2++;

		/*check the Z-Axis with high pass to detect Hits (like hammer)*/
		if((abs(dsHP.z) >= 18) && (winkel <= dDegree) && (bAlarm == FALSE))
		{
			iHitTime++;

			if(iHitTime == 2)
			{
				bAlarm = TRUE;
				//PlaySoundW(sPath, NULL, SND_ASYNC);
				temp.Format(_T("%s Hit"), GetDateCode());
				cEvent.InsertString(0, temp);
				cBitmap.LoadBitmapW(IDB_BITMAP2);
				cStaticBitmap.SetBitmap(cBitmap);
				cBitmap.DeleteObject();
			}
		}
		/*check the Z-Axis ; count up for reset*/
		if((abs(dsHP.z) < 15) && (bAlarm == TRUE) && (iHitTime > 0))
			iCount3++;

		/*check every counter and reset each counter*/
		if((iCount == 525) || (iCount2 == 525) || (iCount3 == 525))
		{
			iCount = 0; //check: tilt
			iCount2 = 0; //check: movement
			iCount3 = 0; //check: hit
			iHitTime = 0; 
			iTiltTime = 0;
			iMoveTime = 0;
			bAlarm = FALSE; //armed
			
			cBitmap.LoadBitmapW(IDB_BITMAP3);
			cStaticBitmap.SetBitmap(cBitmap);
			cBitmap.DeleteObject();
		}
}

/*USB-Function: Read data from interface 0*/
UCHAR CKioskprotectDlg::ReadPipOne(HANDLE handle)
{
	DWORD NumberOfBytesRead = 0;

	memset(&hid.PipeOne, 0, hid.Capabilities.InputReportByteLength+1);
	hid.PipeOne[0] = 0x00;
	
	ReadFile(handle, &hid.PipeOne, hid.Capabilities.InputReportByteLength, &NumberOfBytesRead, NULL);
	return 0;
}

/*Calc lsb and msb to one short-value*/
short CKioskprotectDlg::CalcPipeOne(UCHAR lsb, UCHAR msb)
{
	short erg;
	short LSB, MSB;

	MSB = msb;
	MSB = MSB & 0x00FF;
	LSB = (lsb & 0x03) << 8; // *256
	LSB = LSB & 0x0300;

	erg = MSB | LSB ;

	return erg;
}


/*Calculate with LSB and MSB a unsigned integer (with abs())*/
int CKioskprotectDlg::ReadedData(void)
{
	hid.PipeOne[0] = 0x00;
	ReadPipOne(hid.HidHandle[0]);

	/*Calc the lsb and msb and sub the offset from joystick*/
	tBuffer.x = CalcPipeOne(hid.PipeOne[2], hid.PipeOne[1]) - 512.0; //calc X-Axis
	tBuffer.y = CalcPipeOne(hid.PipeOne[4], hid.PipeOne[3]) - 512.0; //calc Y-Axis
	tBuffer.z = CalcPipeOne(hid.PipeOne[6], hid.PipeOne[5]) - 256.0; //calc Z-Axis

	/*Shift values for FIR-Filter*/
	ShiftBuffer(tBuffer.x, tBuffer.y, tBuffer.z);

	/*Set button-event to local variable*/
	tBuffer.b = hid.PipeOne[7];

	return 0;
}

/*Shift values for FIR-Filter*/
void CKioskprotectDlg::ShiftBuffer(double x, double y, double z)
{
	for(int k=0; k<9; k++)
	{
		dBuffer.x[k] = dBuffer.x[k+1];
		dBuffer.y[k] = dBuffer.y[k+1];
		dBuffer.z[k] = dBuffer.z[k+1];
	}

	dBuffer.x[9] = x;
	dBuffer.y[9] = y;
	dBuffer.z[9] = z;
}


void CKioskprotectDlg::OnClose()
{
	timeKillEvent(idEvent); //kill timer

	if(hid.HidHandle[0] != NULL) //check for handle
	{
		CancelIo(hid.HidHandle[0]);
		CancelIo(hid.HidHandle[1]);

		CloseHandle(hid.HidHandle[0]);
		CloseHandle(hid.HidHandle[1]);
	}

	CDialog::OnClose();
}

void CKioskprotectDlg::OnDateiBeenden()
{
	timeKillEvent(idEvent);//kill timer

	if(hid.HidHandle[0] != NULL) //check for handle
	{
		CancelIo(hid.HidHandle[0]);
		CancelIo(hid.HidHandle[1]);

		CloseHandle(hid.HidHandle[0]);
		CloseHandle(hid.HidHandle[1]);
	}

	OnOK();
}

/*Get systemtime for list*/
CString CKioskprotectDlg::GetDateCode(void)
{
	CString string;
	CTime cTime = CTime::GetCurrentTime();
	
	string.Format(_T("%.2d.%.2d. %.2d:%.2d ! "), cTime.GetDay(), cTime.GetMonth(), cTime.GetHour(), cTime.GetMinute());

	return string;
}

void CKioskprotectDlg::OnDeltaposSpin1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	
	CString string;
	dDegree = pNMUpDown->iPos;
	string.Format(_T("%d"), dDegree);


	GetDlgItem(IDC_STATIC_DEGREE)->SetWindowText(string);

	*pResult = 0;
}
